import processing.sound.*;

Balls [] balls;//the [] brackets indicate an array; it contains a whole list of NPC balls
userBall myBall;// this calls foward the User Ball class in the name of "myBall"
Timer timer;
PImage Ballsimg;
PImage collidedBallImg;
boolean buttonPressed;
int buttonX, buttonY, buttonW, buttonH;
int amountcollided;//the amount of times that the balls have collided
String S= "You Win! \n Press the mouse to restart";
SoundFile backgroundmusic;
int gameState;
int numberofballs=10;

void setup() {
  size(1280, 800);
  gameState=0;
  //Assume the start button has not been pressed
  buttonPressed = false;

  //Parameters for the start button 
  buttonW=335;
  buttonH=100;
  textSize(buttonH);
  buttonX=(width-buttonW)/2;
  buttonY=(height-buttonH)/2;
  Ballsimg= loadImage("Donald Trump Face.png");
  collidedBallImg= loadImage("Donald Trump wearing Facemask.png");
  balls= new Balls [numberofballs];// this allows it to contain 10 of the NPC Balls; this calls the constructor 
  for (int i=0; i<balls.length; i++) {// as long as i is less than 10, it's going to keep on calling on the "Balls" constructor, basically creating new balls 
    balls[i]= new Balls(Ballsimg, collidedBallImg);
  }
  backgroundmusic= new SoundFile(this, "Instruction BG Music.mp3");
  myBall= new userBall();//calls on the userBall constructor to create the user Ball in the name of "myBall"
}

void draw() {
  background(255);
  //code for instructions and start button
  if (gameState==0) { //if the Start button is pressed, run the game code 
    //timer.showTimer();//shows the timer on screen
    fill(random(144), random(230), random(166));
    String Instructions= "Instructions: \n Use the arrow keys on your keyboard to control and move the ball around the screen. \n The objective of the game is to make all the other Donald Trump balls wear his mask properly, \n and you will do that by tagging or touching all of them within the time limit of 30 seconds. \n You win if you manage to make all the Donald Trump balls wear a mask. \n You lose if there are still remainig Donald Trump balls not wearing a mask when the time ends."; 
    textAlign(CENTER);
    textSize(20);
    text(Instructions, width/2, height/2-200);
    fill(random(255), random(255), random(255));
    rect(buttonX, buttonY+200, buttonW+65, buttonH);
    fill(255, 0, 0);
    textSize(50);
    text("PRESS TO START", buttonX+200, buttonY+200+buttonH-10);
  } else if (gameState==1) {//the gameplay screen with game code
    for (int i=0; i<balls.length; i++) {
      balls[i].drawBalls();//allows all the NPC balls to be drawn on the window
      balls[i].moveBalls();//allows all the NPC balls to move around the window
      balls[i].Ballscheckedge();//allows all the NPC balls to bounce of the edges of the window
    }
    collisiondetection();
    myBall.drawuserBall();
    timer.showTimer();//shows the timer on screen
  } else if (gameState==2) {//win
    //numberofballs+=1;
    background(0);
    fill(random(255), random(255), random(255));
    textAlign(CENTER);
    textSize(80);
    text(S, width/2, height/2);
    if (mousePressed) {
      reset();
    }
  } else if (gameState==3) {//lose
    String G="Time's Up! You Lose! Game Over";
    String R="Press the mouse to restart";
    background(0);
    fill(random(255), random(255), random(255));
    textAlign(CENTER);
    textSize(80);
    text(G, width/2, height/2);
    textSize(50);
    text(R, width/2, height/2+100);
    if (mousePressed) {
      reset();
    }
  }
}

//if the start button is pressed
void mousePressed() {
  if ( mouseX > buttonX && mouseX < buttonX+buttonW+65 && mouseY > buttonY+200 && mouseY < (buttonY+200)+buttonH) {
    //buttonPressed=true;
    gameState=1;
    backgroundmusic.play();
    timer= new Timer();
  }
}
//code to control the user's ball
void keyPressed() { //code for controlling the user's Ball by arrow keys
  if (keyCode== UP && myBall.locy-myBall.radius >=0) myBall.locy-=25;//if the y location of the user's Ball minus the radius of the ellipse is greater or equal to 0, it will move upwards
  else if (keyCode== DOWN && myBall.locy+myBall.radius <=height) myBall.locy+=25;
  else if (keyCode == LEFT && myBall.locx-myBall.radius>=0) myBall.locx-=25;
  else if (keyCode == RIGHT && myBall.locx+myBall.radius<= width) myBall.locx+=25;
}

void collisiondetection() {
  amountcollided=0;
  //putting in aloop for all of the NPC balls 
  for (int i=0; i<balls.length; i++) {
    //if the x and y location distance of any NPC ball and user ball added together is smaller than the radius of the NPC ball and user ball, then it means it has collided
    if (dist(balls[i].locx, balls[i].locy, myBall.locx, myBall.locy)< balls[i].radius + myBall.radius) {
      //println(dist(balls[i].locx, balls[i].locy, myBall.locx, myBall.locy));
      balls[i].iscollided=true; //if it collides, changes the boolean to true, changing the image
    }
    //each time it collides, the boolean is true, making the amountcollided to increment by 1
    if (balls[i].iscollided==true) {
      amountcollided+=1;
    }
  }
  println(amountcollided);
  //the the amount of collisions added up before the timer ends is greater or equal to 20
  if (amountcollided >=balls.length) {//if greater than the amount of balls in the game
    backgroundmusic.stop();
    gameState=2;
  }
}



//this is the state or the code from setup basically in order for the game to be restarted 
void reset() {
  //Assume the start button has not been pressed
  //buttonPressed = false;
  gameState=0;

  //Parameters for the start button 
  buttonW=335;
  buttonH=100;
  textSize(buttonH);
  buttonX=(width-buttonW)/2;
  buttonY=(height-buttonH)/2;
  Ballsimg= loadImage("Donald Trump Face.png");
  collidedBallImg= loadImage("Donald Trump wearing Facemask.png");
  balls= new Balls [numberofballs];// this allows it to contain 10 of the NPC Balls; this calls the constructor 
  for (int i=0; i<balls.length; i++) {// as long as i is less than 10, it's going to keep on calling on the "Balls" constructor, basically creating new balls 
    balls[i]= new Balls(Ballsimg, collidedBallImg);
  }
  backgroundmusic= new SoundFile(this, "Instruction BG Music.mp3");
  myBall= new userBall();//calls on the userBall constructor to create the user Ball in the name of "myBall"
}
